/*
* Copyright 2020 Kumori systems S.L.
*
* Licensed under the EUPL, Version 1.2 or – as soon they
* will be approved by the European Commission - subsequent
* versions of the EUPL (the "Licence");
* You may not use this work except in compliance with the
* Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl
*
* Unless required by applicable law or agreed to in
* writing, software distributed under the Licence is
* distributed on an "AS IS" basis,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing
* permissions and limitations under the Licence.
 */
// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1beta2 "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/apis_aws/aws/v1beta2"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeAWSClusterControllerIdentities implements AWSClusterControllerIdentityInterface
type FakeAWSClusterControllerIdentities struct {
	Fake *FakeInfrastructureV1beta2
	ns   string
}

var awsclustercontrolleridentitiesResource = schema.GroupVersionResource{Group: "infrastructure.cluster.x-k8s.io", Version: "v1beta2", Resource: "awsclustercontrolleridentities"}

var awsclustercontrolleridentitiesKind = schema.GroupVersionKind{Group: "infrastructure.cluster.x-k8s.io", Version: "v1beta2", Kind: "AWSClusterControllerIdentity"}

// Get takes name of the aWSClusterControllerIdentity, and returns the corresponding aWSClusterControllerIdentity object, and an error if there is any.
func (c *FakeAWSClusterControllerIdentities) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1beta2.AWSClusterControllerIdentity, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(awsclustercontrolleridentitiesResource, c.ns, name), &v1beta2.AWSClusterControllerIdentity{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta2.AWSClusterControllerIdentity), err
}

// List takes label and field selectors, and returns the list of AWSClusterControllerIdentities that match those selectors.
func (c *FakeAWSClusterControllerIdentities) List(ctx context.Context, opts v1.ListOptions) (result *v1beta2.AWSClusterControllerIdentityList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(awsclustercontrolleridentitiesResource, awsclustercontrolleridentitiesKind, c.ns, opts), &v1beta2.AWSClusterControllerIdentityList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1beta2.AWSClusterControllerIdentityList{ListMeta: obj.(*v1beta2.AWSClusterControllerIdentityList).ListMeta}
	for _, item := range obj.(*v1beta2.AWSClusterControllerIdentityList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested aWSClusterControllerIdentities.
func (c *FakeAWSClusterControllerIdentities) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(awsclustercontrolleridentitiesResource, c.ns, opts))

}

// Create takes the representation of a aWSClusterControllerIdentity and creates it.  Returns the server's representation of the aWSClusterControllerIdentity, and an error, if there is any.
func (c *FakeAWSClusterControllerIdentities) Create(ctx context.Context, aWSClusterControllerIdentity *v1beta2.AWSClusterControllerIdentity, opts v1.CreateOptions) (result *v1beta2.AWSClusterControllerIdentity, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(awsclustercontrolleridentitiesResource, c.ns, aWSClusterControllerIdentity), &v1beta2.AWSClusterControllerIdentity{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta2.AWSClusterControllerIdentity), err
}

// Update takes the representation of a aWSClusterControllerIdentity and updates it. Returns the server's representation of the aWSClusterControllerIdentity, and an error, if there is any.
func (c *FakeAWSClusterControllerIdentities) Update(ctx context.Context, aWSClusterControllerIdentity *v1beta2.AWSClusterControllerIdentity, opts v1.UpdateOptions) (result *v1beta2.AWSClusterControllerIdentity, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(awsclustercontrolleridentitiesResource, c.ns, aWSClusterControllerIdentity), &v1beta2.AWSClusterControllerIdentity{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta2.AWSClusterControllerIdentity), err
}

// Delete takes name of the aWSClusterControllerIdentity and deletes it. Returns an error if one occurs.
func (c *FakeAWSClusterControllerIdentities) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteActionWithOptions(awsclustercontrolleridentitiesResource, c.ns, name, opts), &v1beta2.AWSClusterControllerIdentity{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeAWSClusterControllerIdentities) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(awsclustercontrolleridentitiesResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1beta2.AWSClusterControllerIdentityList{})
	return err
}

// Patch applies the patch and returns the patched aWSClusterControllerIdentity.
func (c *FakeAWSClusterControllerIdentities) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta2.AWSClusterControllerIdentity, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(awsclustercontrolleridentitiesResource, c.ns, name, pt, data, subresources...), &v1beta2.AWSClusterControllerIdentity{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta2.AWSClusterControllerIdentity), err
}
